Loading...
Searching...
No Matches
casacore::BucketMapped Class Reference
casa package (libcasa_casa) » IO_module

More...

`#include <BucketMapped.h>`

## Public Member Functions

| BucketMapped (BucketFile *file, Int64 startOffset, uInt bucketSize, uInt nrOfBuckets)
| Create the cache for (part of) a file.
| ~BucketMapped ()
| Unmap the file.
const char * | getBucket (uInt bucketNr)
| Get a readonly pointer to the given bucket in memory.
char * | getrwBucket (uInt bucketNr)
| Get a writable pointer to the given bucket in memory.
Public Member Functions inherited from casacore::BucketBase
| BucketBase (BucketFile *file, Int64 startOffset, uInt bucketSize, uInt nrOfBuckets)
| Create the bucket access for (part of) a file.
virtual | ~BucketBase ()
| Detach the file.
Bool | flush ()
| Flush the cached buckets.
virtual void | resync (uInt nrBucket)
| Resynchronize the object (after another process updated the file).
uInt | nBucket () const
| Get the current nr of buckets in the file.
void | extend (uInt nrBucket)
| Extend the file with the given number of buckets.
void | setWritten ()
| Set that data has been written.

## Private Member Functions

| BucketMapped (const BucketMapped &)
| Copy constructor is not possible.
BucketMapped & | operator= (const BucketMapped &)
| Assignment is not possible.
virtual void | doFlush ()
| Flush the file.
virtual void | doResync ()
| Do the actual resync-ing.
virtual void | doExtend (uInt nrBucket)
| Extend the file with the given number of buckets.
virtual void | initializeBuckets (uInt bucketNr)
| Initialize the bucket buffer.

## Additional Inherited Members

Protected Member Functions inherited from casacore::BucketBase
| BucketBase (const BucketBase &)
| Copy constructor is not possible.
BucketBase & | operator= (const BucketBase &)
| Assignment is not possible.
Protected Attributes inherited from casacore::BucketBase
BucketFile * | itsFile
| The file used.
Int64 | itsStartOffset
| The starting offsets of the buckets in the file.
uInt | itsBucketSize
| The bucket size.
uInt | itsCurNrOfBuckets
| The current nr of buckets in the file.
uInt | itsNewNrOfBuckets
| The new nr of buckets in the file (after extension).
Bool | itsHasWritten
| Have data been written?

## Detailed Description

Use file mapping for buckets in a part of a file

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- BucketFile

### Etymology

BucketMapped uses memory-mapped files for bucket access.

### Synopsis

BucketMapped is similar to class BucketCache and is meant to be used by the storage managers of the Table System.

It gives access to buckets in a file by means of memory-mapped files. However, its functionality is a subset of BucketCache and is only meant to be used by the Tiled Storage Managers. If The Standard and Incremental Storage Manager also want to use it, functions like extend needs to be added to this class. Also support for a free bucket list needs to be added.

### Motivation

Use of BucketCache is sub-optimal when having large buckets and more or less random IO. Memory-mapping behaves much better.

Definition at line 74 of file BucketMapped.h.

## Constructor & Destructor Documentation

## BucketMapped() [1/2]

casacore::BucketMapped::BucketMapped | ( | BucketFile * | file,
|  | Int64 | startOffset,
|  | uInt | bucketSize,
|  | uInt | nrOfBuckets )

Create the cache for (part of) a file.

The file part mapped into memory starts at startOffset. Its length is bucketSize*nrOfBuckets bytes. If the file is smaller, the remainder is indicated as an extension similarly to the behaviour of function extend.

Referenced by BucketMapped(), and operator=().

## ~BucketMapped()

casacore::BucketMapped::~BucketMapped | ( |  | ) |

Unmap the file.

## BucketMapped() [2/2]

casacore::BucketMapped::BucketMapped | ( | const BucketMapped & |  | ) |

private

Copy constructor is not possible.

References BucketMapped().

## Member Function Documentation

## doExtend()

virtual void casacore::BucketMapped::doExtend | ( | uInt | nrBucket | ) |

private virtual

Extend the file with the given number of buckets.

Implements casacore::BucketBase.

## doFlush()

virtual void casacore::BucketMapped::doFlush | ( |  | ) |

private virtual

Flush the file.

Implements casacore::BucketBase.

## doResync()

virtual void casacore::BucketMapped::doResync | ( |  | ) |

private virtual

Do the actual resync-ing.

Implements casacore::BucketBase.

## getBucket()

const char * casacore::BucketMapped::getBucket | ( | uInt | bucketNr | ) |

Get a readonly pointer to the given bucket in memory.

Referenced by getrwBucket().

## getrwBucket()

char * casacore::BucketMapped::getrwBucket | ( | uInt | bucketNr | ) |

inline

Get a writable pointer to the given bucket in memory.

It sets the hasWritten flag.

Definition at line 93 of file BucketMapped.h.

References getBucket(), casacore::BucketBase::itsHasWritten, and casacore::True.

## initializeBuckets()

virtual void casacore::BucketMapped::initializeBuckets | ( | uInt | bucketNr | ) |

private virtual

Initialize the bucket buffer.

The uninitialized buckets before this bucket are also initialized.

Implements casacore::BucketBase.

## operator=()

BucketMapped & casacore::BucketMapped::operator= | ( | const BucketMapped & |  | ) |

private

Assignment is not possible.

References BucketMapped().

The documentation for this class was generated from the following file:

- casa/IO/BucketMapped.h